var RetractionFollowUpForm = function()
{
	var rf = {};
	
	var patients;
	var selectedPatient;
	var action;
	var allCanBeDeleted = false;
 	
	var labSentDateIsValid = false;
	var labReceivedDateIsValid = false;
	var bloodSentDateIsValid = false;
	var bloodReceivedDateIsValid = false;
	var frozenSentDateIsValid = false;
	var frozenReceivedDateIsValid = false;
	var forwardedSentDateIsValid = false;
	var rccSydSentDateIsValid = false;
	var debug = 0;
	
	rf.initPage = function()
	{

		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', rf.validateStep1);
		
		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', rf.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', rf.validateStep2);
		Events.addEventHandler('labDateNa', 'change', rf.labDateNaOnChange);
		Events.addEventHandler('labSentDate', 'blur', rf.labDateOnChange);
		Events.addEventHandler('labReceivedDate', 'blur', rf.labDateOnChange);
		Events.addEventHandler('bloodDateNa', 'change', rf.bloodDateNaOnChange);
		Events.addEventHandler('bloodSentDate', 'blur', rf.bloodDateOnChange);
		Events.addEventHandler('bloodReceivedDate', 'blur', rf.bloodDateOnChange);
		Events.addEventHandler('frozenDateNa', 'change', rf.frozenDateNaOnChange);
		Events.addEventHandler('frozenSentDate', 'blur', rf.frozenDateOnChange);
		Events.addEventHandler('frozenReceivedDate', 'blur', rf.frozenDateOnChange);
		Events.addEventHandler('forwardedDateNa', 'change', rf.forwardedDateNaOnChange);
		Events.addEventHandler('forwardedSentDate', 'blur', rf.forwardedDateOnChange);
		Events.addEventHandler('rccSydDateNa', 'change', rf.rccSydDateNaOnChange);
		Events.addEventHandler('rccSydSentDate', 'blur', rf.rccSydDateOnChange);

		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);		

		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', rf.submit);
		
		
		var url = '../Retraction.servlet?ID='+App.getSessionId();
		url += '&cmd=LoadPatientsForRetraction';
		Wizard.showLoadingAnimation('Loading patients for retraction...');
		Wizard.asyncJsonRequest(url, rf.onPatientsLoaded);
	}

	
	rf.onPatientsLoaded = function(response)
	{
		patients = response.patients;
		if (patients.length == 0)
		{
			Wizard.setFatalError('No cases available for retraction.');
			return;
		}
		var frm = document.forms['reggie'];
		
		var html = '';
		for (var patNo = 0; patNo < patients.length; patNo++)
		{
			var patient = patients[patNo];
			var readyForDestruction = patient.RetractStatus == 'ReadyForDestruction';
			
			html += '<tr class="highlight ' + (patNo % 2 == 0 ? 'oddrow' : 'evenrow') + '" id="patient.'+patient.id + '">';
			html += '<td>'+(patNo+1)+'</td>';
			html += '<td class="dottedleft">';
			html += '<span class="link item-link" data-item-type="BIOSOURCE" data-item-id="'+patient.id+'">';
			html += Strings.encodeTags(patient.name);
			html += '</td>';
			html += '<td>'+Strings.encodeTags(patient.PersonalNumber)+'</td>';
			html += '<td class="dottedleft">';
			for (var caseNo = 0; caseNo < patient.cases.length; caseNo++)
			{
				var c = patient.cases[caseNo];
				if (caseNo > 0) html += '<br>';
				html += '<span class="link item-link" data-item-type="SAMPLE" data-item-id="'+c.id+'">';
				html += Strings.encodeTags(c.name); // + ' [' + c.laterality + ']';
				html += '</span>';
				html += '<img class="link case-summary" data-name="'+Strings.encodeTags(c.name)+'" src="../images/case_summary.png">';
			}
			html += '</td>';
			
			if (patient.RetractNaLab)
			{
				html += '<td class="dottedleft" colspan="2">n/a</td>';
			}
			else
			{
				html += '<td class="dottedleft">'+Reggie.reformatDate(patient.RetractTxLab) + '</td>';
				html += '<td>'+Reggie.reformatDate(patient.RetractRxLab) + '</td>';
			}
			if (patient.RetractNaBb)
			{
				html += '<td class="dottedleft" colspan="2">n/a</td>';
			}
			else
			{
				html += '<td class="dottedleft">'+Reggie.reformatDate(patient.RetractTxBb) + '</td>';
				html += '<td>'+Reggie.reformatDate(patient.RetractRxBb) + '</td>';
			}
			if (patient.RetractNaFrozen)
			{
				html += '<td class="dottedleft" colspan="2">n/a</td>';
			}
			else
			{
				html += '<td class="dottedleft">'+Reggie.reformatDate(patient.RetractTxFrozen) + '</td>';
				html += '<td>'+Reggie.reformatDate(patient.RetractRxFrozen) + '</td>';
			}
			if (patient.RetractNaExt)
			{
				html += '<td class="dottedleft">n/a</td>';
			}
			else
			{
				html += '<td class="dottedleft">'+Reggie.reformatDate(patient.RetractTxExt) + '</td>';
			}
			if (patient.RetractNaRccSyd)
			{
				html += '<td class="dottedleft">n/a</td>';
			}
			else
			{
				html += '<td class="dottedleft">'+Reggie.reformatDate(patient.RetractTxRccSyd) + '</td>';
			}
			html += '<td class="dottedleft">';
			html += '<span class="link edit-action" data-index="'+patNo+'">Edit<img src="../images/gonext.png"></span>';
			html += '</td>';
			html += '<td>'
			if (readyForDestruction)
			{
				html += '<span class="link destruct-action" data-index="'+patNo+'">';
				html += 'Destruct<img src="../images/gonext.png"></span>';
			}
			html += '</td>';
			html += '</tr>';
		}
		
		Doc.element('patient-list').innerHTML = html;
		Doc.show('step-1');

		var cs = document.getElementsByClassName('item-link');
		for (var i = 0; i < cs.length; i++)
		{
			Events.addEventHandler(cs[i], 'click', Items.itemOnClick);
		}

		var cs = document.getElementsByClassName('case-summary');
		for (var i = 0; i < cs.length; i++)
		{
			Events.addEventHandler(cs[i], 'click', Reggie.openCaseSummaryPopupOnEvent);
		}
		
		var cs = document.getElementsByClassName('edit-action');
		for (var i = 0; i < cs.length; i++)
		{
			Events.addEventHandler(cs[i], 'click', rf.goEdit);
		}
		
		var cs = document.getElementsByClassName('destruct-action');
		for (var i = 0; i < cs.length; i++)
		{
			Events.addEventHandler(cs[i], 'click', rf.goDestruct);
		}
		
		Doc.show('step-1');
	}

	rf.goDestruct = function(event)
	{
		var index = Data.get(event.currentTarget, 'index');
		selectedPatient = patients[index];
		action = 'destruct';
		Wizard.goNext();
	}
	
	rf.goEdit = function(event)
	{
		var index = Data.get(event.currentTarget, 'index');
		selectedPatient = patients[index];
		action = 'edit';
		Wizard.goNext();
	}
	
	/**
		Check that a patient has been selected.
	*/
	rf.validateStep1 = function(event)
	{
		if (!selectedPatient) event.preventDefault();
	}


	/**
		Load information about the given case.
	*/
	rf.initializeStep2 = function(event)
	{
		var frm = document.forms['reggie'];
		var p = selectedPatient;
		if (action == 'edit')
		{
			Doc.element('step-2-title').innerHTML = 'Retraction follow-up';
			Doc.element('patientInfo.name').innerHTML = Strings.encodeTags(p.name);
			rf.setNaAndDates(frm.labDateNa, frm.labSentDate, frm.labReceivedDate, p.RetractNaLab, p.RetractTxLab, p.RetractRxLab);
			rf.setNaAndDates(frm.bloodDateNa, frm.bloodSentDate, frm.bloodReceivedDate, p.RetractNaBb, p.RetractTxBb, p.RetractRxBb);
			rf.setNaAndDates(frm.frozenDateNa, frm.frozenSentDate, frm.frozenReceivedDate, p.RetractNaFrozen, p.RetractTxFrozen, p.RetractRxFrozen);
			rf.setNaAndDates(frm.forwardedDateNa, frm.forwardedSentDate, null, p.RetractNaExt, p.RetractTxExt, null);
			rf.setNaAndDates(frm.rccSydDateNa, frm.rccSydSentDate, null, p.RetractNaRccSyd, p.RetractTxRccSyd, null);
			rf.currentRetractionStatus();

			Doc.show('followup-form');
			Doc.show('gocancel');
			Doc.show('goregister');
			Wizard.setCurrentStep(2);
		}
		else if (action == 'destruct')
		{
			Doc.element('step-2-title').innerHTML = 'Retraction destruction';
			var url = '../Retraction.servlet?ID='+App.getSessionId();
			url += '&cmd=GetCaseInfoBeforeDestruction';
			url += '&patientId=' + p.id;
			Wizard.showLoadingAnimation('Loading case information...');
			Wizard.asyncJsonRequest(url, rf.caseInfoLoaded);
		}
	}

	/**
		Initialize N/A and date fields
	*/
	rf.setNaAndDates = function(naField, sentField, receivedField, na, sent, received)
	{
		sentField.value = sent;
		if (receivedField) receivedField.value = received;
		if (na)
		{
			naField.checked = true;
			rf.disabledDate(sentField);
			if (receivedField) rf.disabledDate(receivedField);
		}
	}
	
	/**
		Disable the given date field and store away the current value
	*/
	rf.disabledDate = function(dateField)
	{
		if (dateField.disabled) return;
		dateField.oldValue = dateField.value;
		dateField.value = null;
		dateField.disabled = true;
	}
	
	/**
		Enable the given date field and bring back the old value.
	*/
	rf.enabledDate = function(dateField)
	{
		if (!dateField.disabled) return;
		dateField.value = dateField.oldValue || '';
		dateField.disabled = false;
	}
	
	rf.labDateNaOnChange = function()
	{
		var frm = document.forms['reggie'];		

		var labDateNa = frm.labDateNa.checked;
		if (labDateNa)
		{
			// Disable date fields
			rf.disabledDate(frm.labSentDate);
			rf.disabledDate(frm.labReceivedDate);
			// Set dates as valid
			labSentDateIsValid = true;
			labReceivedDateIsValid = true;
			// Set input as valid
			Wizard.setInputStatus('labDate', 'valid');
		}
		else
		{
			// Enable date fields
			rf.enabledDate(frm.labSentDate);
			rf.enabledDate(frm.labReceivedDate);
			// Set date valid status
			labSentDateIsValid = false;
			var labSentDate = frm.labSentDate.value;
			if (labSentDate != null)
			{
				labSentDateIsValid = true;
			}
			labReceivedDateIsValid = false;
			var labReceivedDate = frm.labReceivedDate.value;
			if (labReceivedDate != null)
			{
				labReceivedDateIsValid = true;
			}
			// Reset input status
			if (labSentDateIsValid && labReceivedDateIsValid)
			{
				Wizard.setInputStatus('labDate', 'valid');
			}
			else if (labSentDate != null && labReceivedDate != null)
			{
				Wizard.setInputStatus('labDate');
			}
		}
		rf.currentRetractionStatus();
	}

	rf.labDateOnChange = function()
	{
		Wizard.setInputStatus('labDate');
		var frm = document.forms['reggie'];		

		labSentDateIsValid = false;
		var labSentDate = frm.labSentDate.value;
		labSentDate = rf.dateCheck(labSentDate, 'lab sent', 'labDate');		
		if (labSentDate != null)
		{
			frm.labSentDate.value = labSentDate;
			labSentDateIsValid = true;
		}

		labReceivedDateIsValid = false;
		var labReceivedDate = frm.labReceivedDate.value;
		labReceivedDate = rf.dateCheck(labReceivedDate, 'lab received', 'labDate');		
		if (labReceivedDate != null)
		{
			frm.labReceivedDate.value = labReceivedDate;
			labReceivedDateIsValid = true;
		}

		if (labSentDateIsValid && labReceivedDateIsValid)
		{
			var result = rf.causalityDateCheck(labSentDate, 'lab sent', labReceivedDate, 'lab received', 'labDate');
			if (result != null)
			{
				Wizard.setInputStatus('labDate', 'valid');
			}
		}
		else if (labSentDate != null && labReceivedDate != null)
		{
			Wizard.setInputStatus('labDate');
		}		
		rf.currentRetractionStatus();
	}

	rf.bloodDateNaOnChange = function()
	{
		var frm = document.forms['reggie'];		

		var bloodDateNa = frm.bloodDateNa.checked;
		if (bloodDateNa)
		{
			// Disable date fields
			rf.disabledDate(frm.bloodSentDate);
			rf.disabledDate(frm.bloodReceivedDate);
			// Set dates as valid
			bloodSentDateIsValid = true;
			bloodReceivedDateIsValid = true;
			// Set input as valid
			Wizard.setInputStatus('bloodDate', 'valid');
		}
		else
		{
			// Enable date fields
			rf.enabledDate(frm.bloodSentDate);
			rf.enabledDate(frm.bloodReceivedDate);
			// Set date valid status
			bloodSentDateIsValid = false;
			var bloodSentDate = frm.bloodSentDate.value;
			if (bloodSentDate != null)
			{
				bloodSentDateIsValid = true;
			}
			bloodReceivedDateIsValid = false;
			var bloodReceivedDate = frm.bloodReceivedDate.value;
			if (bloodReceivedDate != null)
			{
				bloodReceivedDateIsValid = true;
			}
			// Reset input status
			if (bloodSentDateIsValid && bloodReceivedDateIsValid)
			{
				Wizard.setInputStatus('bloodDate', 'valid');
			}
			else if (bloodSentDate != null && bloodReceivedDate != null)
			{
				Wizard.setInputStatus('bloodDate');
			}
		}
		rf.currentRetractionStatus();
	}

	rf.bloodDateOnChange = function()
	{
		Wizard.setInputStatus('bloodDate');
		var frm = document.forms['reggie'];		

		bloodSentDateIsValid = false;
		var bloodSentDate = frm.bloodSentDate.value;
		bloodSentDate = rf.dateCheck(bloodSentDate, 'blood sent', 'bloodDate');		
		if (bloodSentDate != null)
		{
			frm.bloodSentDate.value = bloodSentDate;
			bloodSentDateIsValid = true;
		}

		bloodReceivedDateIsValid = false;
		var bloodReceivedDate = frm.bloodReceivedDate.value;
		bloodReceivedDate = rf.dateCheck(bloodReceivedDate, 'blood received', 'bloodDate');		
		if (bloodReceivedDate != null)
		{
			frm.bloodReceivedDate.value = bloodReceivedDate;
			bloodReceivedDateIsValid = true;
		}

		if (bloodSentDateIsValid && bloodReceivedDateIsValid)
		{
			var result = rf.causalityDateCheck(bloodSentDate, 'blood sent', bloodReceivedDate, 'blood received', 'bloodDate');
			if (result != null)
			{
				Wizard.setInputStatus('bloodDate', 'valid');
			}
		}
		else if (bloodSentDate != null && bloodReceivedDate != null)
		{
			Wizard.setInputStatus('bloodDate');
		}		
		rf.currentRetractionStatus();
	}

	rf.frozenDateNaOnChange = function()
	{
		var frm = document.forms['reggie'];		

		var frozenDateNa = frm.frozenDateNa.checked;
		if (frozenDateNa)
		{
			// Disable date fields
			rf.disabledDate(frm.frozenSentDate);
			rf.disabledDate(frm.frozenReceivedDate);
			// Set dates as valid
			frozenSentDateIsValid = true;
			frozenReceivedDateIsValid = true;
			// Set input as valid
			Wizard.setInputStatus('frozenDate', 'valid');
		}
		else
		{
			// Enable date fields
			rf.enabledDate(frm.frozenSentDate);
			rf.enabledDate(frm.frozenReceivedDate);
			// Set date valid status
			frozenSentDateIsValid = false;
			var frozenSentDate = frm.frozenSentDate.value;
			if (frozenSentDate != null)
			{
				frozenSentDateIsValid = true;
			}
			frozenReceivedDateIsValid = false;
			var frozenReceivedDate = frm.frozenReceivedDate.value;
			if (frozenReceivedDate != null)
			{
				frozenReceivedDateIsValid = true;
			}
			// Reset input status
			if (frozenSentDateIsValid && frozenReceivedDateIsValid)
			{
				Wizard.setInputStatus('frozenDate', 'valid');
			}
			else if (frozenSentDate != null && frozenReceivedDate != null)
			{
				Wizard.setInputStatus('frozenDate');
			}
		}
		rf.currentRetractionStatus();
	}

	rf.frozenDateOnChange = function()
	{
		Wizard.setInputStatus('frozenDate');
		var frm = document.forms['reggie'];		

		frozenSentDateIsValid = false;
		var frozenSentDate = frm.frozenSentDate.value;
		frozenSentDate = rf.dateCheck(frozenSentDate, 'frozen sent', 'frozenDate');		
		if (frozenSentDate != null)
		{
			frm.frozenSentDate.value = frozenSentDate;
			frozenSentDateIsValid = true;
		}

		frozenReceivedDateIsValid = false;
		var frozenReceivedDate = frm.frozenReceivedDate.value;
		frozenReceivedDate = rf.dateCheck(frozenReceivedDate, 'frozen received', 'frozenDate');		
		if (frozenReceivedDate != null)
		{
			frm.frozenReceivedDate.value = frozenReceivedDate;
			frozenReceivedDateIsValid = true;
		}

		if (frozenSentDateIsValid && frozenReceivedDateIsValid)
		{
			var result = rf.causalityDateCheck(frozenSentDate, 'frozen sent', frozenReceivedDate, 'frozen received', 'frozenDate');
			if (result != null)
			{
				Wizard.setInputStatus('frozenDate', 'valid');
			}
		}
		else if (frozenSentDate != null && frozenReceivedDate != null)
		{
			Wizard.setInputStatus('frozenDate');
		}		
		rf.currentRetractionStatus();
	}

	rf.forwardedDateNaOnChange = function()
	{
		var frm = document.forms['reggie'];		

		var forwardedDateNa = frm.forwardedDateNa.checked;
		if (forwardedDateNa)
		{
			// Disable date fields
			rf.disabledDate(frm.forwardedSentDate);
			// Set dates as valid
			forwardedSentDateIsValid = true;
			// Set input as valid
			Wizard.setInputStatus('forwardedDate', 'valid');
		}
		else
		{
			// Enable date fields
			rf.enabledDate(frm.forwardedSentDate);
			// Set date valid status
			forwardedSentDateIsValid = false;
			var forwardedSentDate = frm.forwardedSentDate.value;
			if (forwardedSentDate != null)
			{
				forwardedSentDateIsValid = true;
			}
			// Reset input status
			if (forwardedSentDateIsValid)
			{
				Wizard.setInputStatus('forwardedDate', 'valid');
			}
			else if (forwardedSentDate != null)
			{
				Wizard.setInputStatus('forwardedDate');
			}
		}
		rf.currentRetractionStatus();
	}

	rf.forwardedDateOnChange = function()
	{
		Wizard.setInputStatus('forwardedDate');
		var frm = document.forms['reggie'];		

		forwardedSentDateIsValid = false;
		var forwardedSentDate = frm.forwardedSentDate.value;
		forwardedSentDate = rf.dateCheck(forwardedSentDate, 'forwarded sent', 'forwardedDate');		
		if (forwardedSentDate != null)
		{
			frm.forwardedSentDate.value = forwardedSentDate;
			forwardedSentDateIsValid = true;
		}

		if (forwardedSentDateIsValid)
		{
			Wizard.setInputStatus('forwardedDate', 'valid');
		}
		else if (forwardedSentDate != null)
		{
			Wizard.setInputStatus('forwardedDate');
		}		
		rf.currentRetractionStatus();
	}

	rf.rccSydDateNaOnChange = function()
	{
		var frm = document.forms['reggie'];		

		var rccSydDateNa = frm.rccSydDateNa.checked;
		if (rccSydDateNa)
		{
			// Disable date fields
			rf.disabledDate(frm.rccSydSentDate);
			// Set dates as valid
			rccSydSentDateIsValid = true;
			// Set input as valid
			Wizard.setInputStatus('rccSydDate', 'valid');
		}
		else
		{
			// Enable date fields
			rf.enabledDate(frm.rccSydSentDate);
			// Set date valid status
			rccSydSentDateIsValid = false;
			var rccSydSentDate = frm.rccSydSentDate.value;
			if (rccSydSentDate != null)
			{
				rccSydSentDateIsValid = true;
			}
			// Reset input status
			if (rccSydSentDateIsValid)
			{
				Wizard.setInputStatus('rccSydDate', 'valid');
			}
			else if (rccSydSentDate != null)
			{
				Wizard.setInputStatus('rccSydDate');
			}
		}
		rf.currentRetractionStatus();
	}

	rf.rccSydDateOnChange = function()
	{
		Wizard.setInputStatus('rccSydDate');
		var frm = document.forms['reggie'];		

		rccSydSentDateIsValid = false;
		var rccSydSentDate = frm.rccSydSentDate.value;
		rccSydSentDate = rf.dateCheck(rccSydSentDate, 'RCC Syd sent', 'rccSydDate');		
		if (rccSydSentDate != null)
		{
			frm.rccSydSentDate.value = rccSydSentDate;
			rccSydSentDateIsValid = true;
		}

		if (rccSydSentDateIsValid)
		{
			Wizard.setInputStatus('rccSydDate', 'valid');
		}
		else if (rccSydSentDate != null)
		{
			Wizard.setInputStatus('rccSydDate');
		}		
		rf.currentRetractionStatus();
	}

	rf.currentRetractionStatus = function(event)
	{
		// Check if all dates are set to non-blank dates or are N/A 
		var frm = document.forms['reggie'];

		var labSentDateIsSetOrNa = false;
		var labReceivedDateIsSetOrNa = false;
		var bloodSentDateIsSetOrNa = false;
		var bloodReceivedDateIsSetOrNa = false;
		var frozenSentDateIsSetOrNa = false;
		var frozenReceivedDateIsSetOrNa = false;
		var forwardedSentDateIsSetOrNa = false;
		var rccSydSentDateIsSetOrNa = false;

		var labDateNa = frm.labDateNa.checked;
		if (labDateNa)
		{
			labSentDateIsSetOrNa = true;
			labReceivedDateIsSetOrNa = true;
		}
		else
		{
			var labSentDate = frm.labSentDate.value;
			if (labSentDate != null && labSentDate != '')
			{
				labSentDateIsSetOrNa = true;
			}		
			var labReceivedDate = frm.labReceivedDate.value;
			if (labReceivedDate != null && labReceivedDate != '')
			{
				labReceivedDateIsSetOrNa = true;
			}		
		}

		var bloodDateNa = frm.bloodDateNa.checked;
		if (bloodDateNa)
		{
			bloodSentDateIsSetOrNa = true;
			bloodReceivedDateIsSetOrNa = true;
		}
		else
		{
			var bloodSentDate = frm.bloodSentDate.value;
			if (bloodSentDate != null && bloodSentDate != '')
			{
				bloodSentDateIsSetOrNa = true;
			}		
			var bloodReceivedDate = frm.bloodReceivedDate.value;
			if (bloodReceivedDate != null && bloodReceivedDate != '')
			{
				bloodReceivedDateIsSetOrNa = true;
			}		
		}

		var frozenDateNa = frm.frozenDateNa.checked;
		if (frozenDateNa)
		{
			frozenSentDateIsSetOrNa = true;
			frozenReceivedDateIsSetOrNa = true;
		}
		else
		{
			var frozenSentDate = frm.frozenSentDate.value;
			if (frozenSentDate != null && frozenSentDate != '')
			{
				frozenSentDateIsSetOrNa = true;
			}		
			var frozenReceivedDate = frm.frozenReceivedDate.value;
			if (frozenReceivedDate != null && frozenReceivedDate != '')
			{
				frozenReceivedDateIsSetOrNa = true;
			}		
		}

		var forwardedDateNa = frm.forwardedDateNa.checked;
		if (forwardedDateNa)
		{
			forwardedSentDateIsSetOrNa = true;
		}
		else
		{
			var forwardedSentDate = frm.forwardedSentDate.value;
			if (forwardedSentDate != null && forwardedSentDate != '')
			{
				forwardedSentDateIsSetOrNa = true;
			}		
		}

		var rccSydDateNa = frm.rccSydDateNa.checked;
		if (rccSydDateNa)
		{
			rccSydSentDateIsSetOrNa = true;
		}
		else
		{
			var rccSydSentDate = frm.rccSydSentDate.value;
			if (rccSydSentDate != null && rccSydSentDate != '')
			{
				rccSydSentDateIsSetOrNa = true;
			}		
		}

		var datesAreSetOrNa = false;
		if (labSentDateIsSetOrNa &&
			labReceivedDateIsSetOrNa &&
			bloodSentDateIsSetOrNa &&
			bloodReceivedDateIsSetOrNa &&
			frozenSentDateIsSetOrNa &&
			frozenReceivedDateIsSetOrNa &&
			forwardedSentDateIsSetOrNa &&
			rccSydSentDateIsSetOrNa)
		{
			datesAreSetOrNa = true;
		}
		
		if (datesAreSetOrNa)
		{
			Doc.element('retractionStatusAfterRegistration').innerHTML = '&nbsp;Retraction status after registration:<img src=\"../images/ok.png\" style=\"padding-left: 1em;\" />&nbsp;Ready for destruction';
		}
		else
		{
			Doc.element('retractionStatusAfterRegistration').innerHTML = '&nbsp;Retraction status after registration: Not ready for destruction';
		}
	}
	
	rf.dateCheck = function(dateValue, dateName, dateMessageKey)
	{
		if (dateValue != '')
		{
			// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
			dateValue = Reggie.autoFillDate(dateValue, true);

			var d = Dates.parseString(dateValue, 'yyyyMMdd');
			if (d == null)
			{
				Wizard.setInputStatus(dateMessageKey, 'invalid', 'Not a valid '+dateName+' date');
				return null;
			}
			
			var today = new Date();
			if (d.getTime() > today.getTime())
			{
				Wizard.setInputStatus(dateMessageKey, 'invalid', 'Future '+dateName+' date is not valid');
				return null;
			}			
		}
		return dateValue;
	}

	rf.causalityDateCheck = function(date1, dateName1, date2, dateName2, dateMessageKey)
	{
		if (date1 != null && date1 != '' && date2 != null && date2 != '')
		{
			// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
			date1 = Reggie.autoFillDate(date1, true);
			date2 = Reggie.autoFillDate(date2, true);

			var d1 = Dates.parseString(date1, 'yyyyMMdd');
			if (d1 == null)
			{
				Wizard.setInputStatus(dateMessageKey, 'invalid', 'Not a valid '+dateName1+' date');
				return null;
			}
			
			var d2 = Dates.parseString(date2, 'yyyyMMdd');
			if (d2 == null)
			{
				Wizard.setInputStatus(dateMessageKey, 'invalid', 'Not a valid '+dateName2+' date');
				return null;
			}
			
			if (d1.getTime() > d2.getTime())
			{
				Wizard.setInputStatus(dateMessageKey, 'invalid', 'Causality violation: '+dateName1+' date is later than '+dateName2+' date');
				return null;
			}	
		}
		return date1;
	}

	
	/**
		Initalize the second step based on the information we have about the case.
	*/
	rf.caseInfoLoaded = function(response)
	{
		var frm = document.forms['reggie'];
		
		// Sample Items Header row
		var html = '<table id="retractionItemsTable2">';
		html += '<thead class="bg-filled-100">';
		html += '<tr>';
		html += '<th></th>';
		html += '<th>Item</th>';
		html += '<th>Name</th>';
		html += '<th></th>';
		html += '<th>LiasonComment</th>';
		html += '<th>Action</th>';
		html += '</tr>';
		html += '</thead>';
		
		html += '<tbody>';
		
		var items = response.items;
		allCanBeDeleted = true;
		for (var i = 0; i < items.length; i++)
		{
			var item = items[i];
			var comment = item.comment;
			if (comment && comment == 'To be deleted')
			{
				comment = '<b>' + comment + '</b>';
			}
			if (!item.deletePermission)
			{
				allCanBeDeleted = false;
				comment = '<b>No delete permission!</b>';
			}
			html += '<tr class="'+(!item.deletePermission ? 'no-delete' : 'highlight')+'">';
			html += '<th class="index">' + (i+1) + '</th>';
			html += '<td class="dottedleft">' + Strings.encodeTags(item.type) + '</td>';
			html += '<td>' + Strings.encodeTags(item.name) + '</td>';
			if (item.liasonComment)
			{
				html += '<td style="text-align: right;"><input type="checkbox" class="keepLiasonComment" value="'+item.name+'" title="Save this comment on the copy"></td>';
				html += '<td>'+ Strings.encodeTags(item.liasonComment)+'</td>';
			}
			else
			{
				html += '<td colspan="2"></td>';
			}
			html += '<td class="dottedleft">' + comment + '</td>';
			html += '</tr>';
		}
		
		html += '</tbody>';
		html += '</table>';
		Doc.element('retractTable').innerHTML = html;
		Doc.show('retractTable');
		
		Wizard.setCurrentStep(2);
		Doc.show('gocancel');
		if (allCanBeDeleted)
		{
			Doc.show('goregister');
		}
	}

	rf.validateStep2 = function(event)
	{
		if (action == 'edit')
		{
			// Get up-to-date values for date validation variables
			rf.labDateNaOnChange();
			rf.bloodDateNaOnChange();
			rf.frozenDateNaOnChange();
			rf.forwardedDateNaOnChange();
			rf.rccSydDateNaOnChange();
			//
			rf.labDateOnChange();
			rf.bloodDateOnChange();
			rf.frozenDateOnChange();
			rf.forwardedDateOnChange();
			rf.rccSydDateOnChange();

			// Step 2 is valid if all date values are valid ('null' value is allowed)
			var datesAreValid = false;
			if (labSentDateIsValid &&
				labReceivedDateIsValid &&
				bloodSentDateIsValid &&
				bloodReceivedDateIsValid &&
				frozenSentDateIsValid &&
				frozenReceivedDateIsValid &&
				forwardedSentDateIsValid &&
				rccSydSentDateIsValid)
			{
				datesAreValid = true;
			}
			
			if (!datesAreValid) event.preventDefault();
		}
		else if (action == 'destruct')
		{
			if (!allCanBeDeleted) event.preventDefault();
		}
		else
		{
			// Unknown action
			event.preventDefault();
		}
	}
	

	
	
	rf.submit = function()
	{
		var frm = document.forms['reggie'];

		if (action == 'edit')
		{
			var retractionInfo = {};
			// Patient
			retractionInfo.patientId = selectedPatient.id;
			// Lab; Note! null value for unchecked N/A box 
			retractionInfo.labDateNa = frm.labDateNa.checked || null;
			retractionInfo.labSentDate = frm.labSentDate.value;
			retractionInfo.labReceivedDate = frm.labReceivedDate.value;
			// Blood
			retractionInfo.bloodDateNa = frm.bloodDateNa.checked || null;
			retractionInfo.bloodSentDate = frm.bloodSentDate.value;
			retractionInfo.bloodReceivedDate = frm.bloodReceivedDate.value;
			// Frozen
			retractionInfo.frozenDateNa = frm.frozenDateNa.checked || null;
			retractionInfo.frozenSentDate = frm.frozenSentDate.value;
			retractionInfo.frozenReceivedDate = frm.frozenReceivedDate.value;
			// Forwarded
			retractionInfo.forwardedDateNa = frm.forwardedDateNa.checked || null;
			retractionInfo.forwardedSentDate = frm.forwardedSentDate.value;
			// RCC Syd
			retractionInfo.rccSydDateNa = frm.rccSydDateNa.checked || null;
			retractionInfo.rccSydSentDate = frm.rccSydSentDate.value;

			var submitInfo = {};
			submitInfo.retractionInfo = retractionInfo;
			
			var url = '../Retraction.servlet?ID=' + App.getSessionId();
			url += '&cmd=RegisterFollowUp';
	
			Wizard.showLoadingAnimation('Performing registration...');
			Wizard.asyncJsonRequest(url, rf.submissionResults, 'POST', JSON.stringify(submitInfo));
		}
		else if (action == 'destruct')
		{
			var retractionInfo = {};
			retractionInfo.patientId = selectedPatient.id;

			var keepLiasonComments = [];
			var checkboxes = document.getElementsByClassName('keepLiasonComment');
			for (var cbNo = 0; cbNo < checkboxes.length; cbNo++)
			{
				var cb = checkboxes[cbNo];
				if (cb.checked) keepLiasonComments[keepLiasonComments.length] = cb.value;
			}
			retractionInfo.keepLiasonComments = keepLiasonComments;
			
			var submitInfo = {};
			submitInfo.retractionInfo = retractionInfo;

			var url = '../Retraction.servlet?ID=' + App.getSessionId();
			url += '&cmd=RegisterDestruction';

			Wizard.showLoadingAnimation('Performing registration...');
			Wizard.asyncJsonRequest(url, rf.submissionResults, 'POST', JSON.stringify(submitInfo));
		}
	}
	
	rf.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}

	return rf;
}();

Doc.onLoad(RetractionFollowUpForm.initPage);

